% Teststoch trace norm minimization


if 1 % Generate sample ratings data
n=10;
r=2;
nrts=4;
observ=0.5;
rand('state',1);
U=round(sqrt(nrts)*rand(n,r));
Aorig=U*U';
tidx=find(triu(ones(n,n)));
obidx=tidx(randperm(length(tidx)));obidx=obidx(1:floor(observ*length(tidx)/2));
A=zeros(n,n);A(obidx)=Aorig(obidx);A=A+tril(A',-1);
end


if 1 % Approx subgradient MATLAB code with columnwise subsampling
% ***** Algo parameters *****
maxiter=2000;
checkf=10;
ps=0.5;
alpha=1; 
c=floor(ps*n);rv=rand(1,c);
B=10;
rnk=2;
iterfac=1.5;
% ***************************
profile on
As=sparse(A);
tic
[X1,Xav1,ovals1,movals1,gaps1,cput1]=ColTraceNorm(As,r,B,ps,alpha,maxiter,checkf,0);
%[X2,Xav2,ovals2,movals2,gaps2,cput2]=DetTraceNorm(As,r,B,alpha,maxiter,checkf,0);
toc
movals1=movals1(find(movals1));
profile off
end
%sum(sum(abs(round(X)-A)>0))
%spy(round(X)-A)
%Aorig
%[svd(A),svd(X)]
%[norm(A,'fro')^2/norm(A)^2,norm(X,'fro')^2/norm(X)^2]
