% Test C Stochastic gradient code.

load AmatSample
Amat=Amat';
    
stepscal=0.2;
[avx,ovals1,movals1,gaps,cput]=DetGrad(Amat,bvec,cvec,B,stepscal,200,20,0);


if 0
tic
% Launch subgradient code
y=zeros(size(Amat,1),1);yav3=y;ovals3=[];movals3=[];
hv=alpha/sqrt(maxiter);ogap=[];
for k=0:maxiter
    % Compute gradient
    [u,sigma]=lmeig(reshape(Amat'*y-cvec,n,n));
    grad=sign(sigma)*Amat*vec(u*u')-bvec;
    % Record function value
    ovals3=[ovals3,abs(sigma)-bvec'*y];
    %ogap=[ogap;(abs(sigma)-bvec'*y)-dualvalue(Amat,bvec,cvec,vec(u*u'),B)];
    % Take step
    y=y-hv*grad;
    % Project
    y=y/max(1,norm(y)/B);
    % Compute average
    yav3=(k*yav3+y)/(k+1);
    if mod(k,checkf)==0
        [u,sigma]=lmeig(reshape(Amat'*yav3-cvec,n,n));
        movals3=[movals3;[k,abs(sigma)-bvec'*yav3]];
    end
end
toc
%movals=diag(1./(1:maxiter))*tril(ones(maxiter,maxiter))*ovals';
end