function [u,sigma,sgn]=lmeig(S,k)
% Compute maximum eigenvalue and eigenvector of S
n=size(S,1);
algo=1;

if nargin<2
    k=1;
end

%tic
if 1
    if n==1
        u=1;sigma=abs(S);sgn=sign(S);
    else
        if 1
            options.disp=0;
            options.issym=1;
            [u,sigma,flag]=eigs(0.5*(S+S'),k,'lm',options); % ARPACK: Faster for large problems but relatively unstable
            flag=0;sigma=diag(sigma);
            mbuf=S*u;mbuf=u.*mbuf;sgn=sign(sum(mbuf));
        else
            [u,sigma,nconv]=SpMaxEig(S,1,1,1e-6,300);
        end
    end
else
    [V,D]=eig(0.5*(S+S'));
    [sigma,idm]=max(abs(diag(D)));
    u=V(:,idm);
end