function [u,sigma]=maxeig(S)
% Compute maximum eigenvalue and eigenvector of S
n=size(S,1);
algo=1;
eigt='la';

if 0
    if n==1
        u=1;sigma=S;
    else
        options.disp=0;
        options.issym=1;
        [u,sigma,flag]=eigs(0.5*(S+S'),1,eigt,options); % ARPACK: Faster for large problems but relatively unstable
        flag=0;
    end
else
    [V,D]=eig(0.5*(S+S'));
    [sigma,idm]=max(diag(D));
    u=V(:,idm);
end